			/* Problem solving using C */
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#define ARRAY_SIZE 60

enum Boolean_enum
{
	FALSE,TRUE
};

struct student_struct
{
	int idno;
	char major_code[4];
	int year;
	char status;
};
				/* pototype */

void search_list(int search_key,int list_size,const struct student_struct array_to_search[],enum Boolean_enum *success,int *index);
void search_student_list(int list_size,const struct student_struct student_list[],enum Boolean_enum list_created);
void print_student_list(int list_size,const struct student_struct student_list[],enum Boolean_enum list_created);
void create_student_list(int *list_size,struct student_struct student_list[],enum Boolean_enum *list_created);
void order_student_list(int list_size,struct student_struct student_list[],enum Boolean_enum list_created);
void order_list(int list_size,struct student_struct array_to_sort[]);
void print_list(int list_size,const struct student_struct arry[]);
void input_list(int *list_size,	struct student_struct arry[]);
void print_menu_and_get_choice(int *choice);

void main (void)
{
	struct student_struct student_list[ARRAY_SIZE];
	int list_size,choice;
	enum Boolean_enum continue_processing=TRUE,list_created=FALSE;
	while(continue_processing==TRUE)
	{
		print_menu_and_get_choice(&choice);
		switch(choice)
		{
			case 1:
				create_student_list(&list_size,student_list,&list_created);
				break;
			case 2:
				print_student_list(list_size,student_list,list_created);
				break;
			case 3:
				order_student_list(list_size,student_list,list_created);
				break;
			case 4:
				search_student_list(list_size,student_list,list_created);
				break;
			case 5:
				continue_processing=FALSE;
				printf("Terminating...........");
				break;
			default:
				printf("Wrong choice; Try again.\n");

		}
	}

}
void print_menu_and_get_choice(int *choice)
{
	printf("\n");
	printf("+-------------------------------------+\n");
	printf("| To create an unsorted list---Type 1 |\n");
	printf("| To print the list------------Type 2 |\n");
	printf("| To sort the list by idno-----Type 3 |\n");
	printf("| To search the list-----------Type 4 |\n");
	printf("| To terminate program---------Type 5 |\n");
	printf("+-------------------------------------+\n\n");
	printf("Enter your chioce: ");
	scanf("%d",&*choice);
}
void create_student_list(int *list_size,
	struct student_struct student_list[],enum Boolean_enum *list_created)
{
	input_list(&*list_size,student_list);
	*list_created=TRUE;

	printf("A list of size %d has been created.\n",*list_size);
}
void input_list(int *list_size,	struct student_struct arry[])
{
	int j;
	char new_line;
	printf("Enter number of students: ");
	scanf("%d",&*list_size);

	for(j=0;j < *list_size;j++)
	{
		printf("Enter idno for the %dth student        : ",j+1);
		scanf("%d",&arry[j].idno);
		scanf("%c",&new_line);

		printf("Enter Major Code for the %dth student  : ",j+1);
		gets(arry[j].major_code);

		printf("Enter Year for the %dth student        : ",j+1);
		scanf("%d",&arry[j].year);
		scanf("%c",&new_line);

		printf("Enter Status for the %dth student      : ",j+1);
		scanf("%c",&arry[j].status);
	}
}
void print_student_list(int list_size,
	const struct student_struct student_list[],
	enum Boolean_enum list_created)
{
	if(list_created==TRUE)
	{
		printf("printing the list:\n");
		print_list(list_size,student_list);
		printf("\n");
	}
	else
		printf("The list has not yet been created.\n");
}
void print_list(int list_size,const struct student_struct arry[])
{
	int t;

	printf("Index     Idno    Major    Year     Status\n");

	for(t=0;t < list_size;t++)
		printf("%3d%9d%9s%10d%12c\n",t+1,arry[t].idno,
		arry[t].major_code,arry[t].year,arry[t].status);
}
void order_student_list(int list_size,struct student_struct student_list[],
					enum Boolean_enum list_created)
{
	if(list_created==TRUE)
	{
		order_list(list_size,student_list);
		printf("The list has been sorted by idno.\n");
	}
	else
		printf("The list has not yet been created.\n");
}
void order_list(int list_size,struct student_struct array_to_sort[])
{
	int i,index_of_largest,last;
	struct student_struct temp;
	for(last=list_size-1;last>=1;last--)
	{
		index_of_largest=0;
		for(i=1;i<=last;i++)
			if(array_to_sort[i].idno > array_to_sort[index_of_largest].idno)
				index_of_largest=i;
			temp=array_to_sort[last];
			array_to_sort[last]=array_to_sort[index_of_largest];
			array_to_sort[index_of_largest]=temp;
	}
}
void search_student_list(int list_size,
	const struct student_struct student_list[],
	enum Boolean_enum list_created)
{
	int index, key;
	enum Boolean_enum success;
	if(list_created==TRUE)
	{
		printf("Enter a student idno as the search key value:" );
		scanf("%d",&key);
		search_list(key,list_size,student_list,&success,&index);
		if(success==TRUE)
		{
			printf("\nStudent %d is in the array.\n",key);
			printf("Idno : %d.\n",student_list[index].idno);
			printf("Major: %s\n",student_list[index].major_code);
			printf("Year : %d.\n",student_list[index].year);
			printf("\nStatus: %c.\n",student_list[index].status);
		}
		else
			printf("\nStudent %d is not in the array.\n",key);
	}
	else
		printf("\nThe list has not yet been created.\n");
}
void search_list(int search_key,int list_size,
	const struct student_struct array_to_search[],
	enum Boolean_enum *success,int *index)
{
	int first,last,mid;
	*success=FALSE;
	*index=ARRAY_SIZE+1;
	first=0;
	last=list_size-1;

	while(first<=last && *success==FALSE)
	{
		mid=(int)(first+last)/2;
		if(array_to_search[mid].idno==search_key)
		{
			*index=mid;
			*success=TRUE;
		}
		else if(array_to_search[mid].idno > search_key)
			last=mid-1;
		else
			first=mid+1;
	}
}